using System;
using System.Threading;
using Plux;
[Extension("MyApp")]
[Plug("Startup")]
[Slot("Logger", OnPlugged = "AddLogger", OnUnplugged = "RemoveLogger")]
public class MyApp : IStartup {
	ILogger logger = null; // the logger extension
	string timeFormat;     // parameter of the logger extension

  public void AddLogger(object s, PlugEventArgs ea)  {
	  Console.WriteLine("AddLogger={0}", ea.PlugInfo.ExtensionInfo.Name);
    logger = ea.Extension as ILogger;
    timeFormat = ea.GetParamValue("TimeFormat") as string;
	}
  public void RemoveLogger(object source, PlugEventArgs ea)  {
	  Console.WriteLine("RemoveLogger={0}", ea.PlugInfo.ExtensionInfo.Name);
		logger = null;
	}
	public void Run() {
		string msg;
		while(true) {
			DoSomeAction(out msg);
			if(logger != null) {
				string time = DateTime.Now.ToString(timeFormat);
				logger.Print(time + ": " + msg);
			} 
			Thread.Sleep(1500);
		}
	}
	public void DoSomeAction(out string msg) { msg = "Hello"; }
}